<?php
include("/home/WiserBot/data/Wiser/classes/user.class.php");
include("/home/WiserBot/data/Wiser/classes/channel.class.php");
include("/home/WiserBot/data/Wiser/classes/bot.class.php");
include("/home/WiserBot/data/Wiser/common/mysql.php");
include("/home/WiserBot/data/Wiser/common/io.php");

//Connect to the database.
$__DB_LINK=db_connect(MYSQL_HOST, MYSQL_UNAME, MYSQL_PWORD, MYSQL_DB);

if (!$__DB_LINK){
	echo "Couldn't connect to Database\n";
	exit;
}

//Get the info that was posted.
$INFO=unserialize(stripslashes($_POST['INFO']));
foreach ($INFO as $key=>$val){
		$INFO[$key]=urldecode($val);
}

//Setup a user
$_User=new User($INFO['NICK']);

//Setup the bot object.
$_Bot=new Bot();

//Set embedded flag
$Embedded=$INFO['EMBEDDED'];
//Wise_Notice(): Sends a notice to the person
function Wise_Notice($to, $msg){
	global $Embedded;
	if (empty($to) || empty($msg)){
		return false;
	}
	if (!$Embedded){
		$msg=str_replace("\r\n", "\n", $msg);
		$msg=str_replace("\r", "\n", $msg);
		$msg=str_replace("\n", "\nNOTICE $to :", $msg);
		$msg="NOTICE $to :".$msg;
	}
	Wise_Raw($msg);
}

//Wise_Msg(): Sends a message to the person
function Wise_Msg($to, $msg){
	global $Embedded;
	if (empty($to) || empty($msg)){
		return false;
	}
	if (!$Embedded){
		$msg=str_replace("\r\n", "\n", $msg);
		$msg=str_replace("\r", "\n", $msg);
		$msg=str_replace("\n", "\nPRIVMSG $to :", $msg);
		$msg="PRIVMSG $to :{$msg}";
	}
	Wise_Raw($msg);
}

//Wise_Ctcp(): CTCP(Client to Client Protocol) encodes a message
function Wise_Ctcp($msg){
	global $Embedded;
	if (empty($msg)){
		return false;
	}
	return chr(1).$msg.chr(1);
}

//Wise_Quit(): Quits IRC sending the given message
function Wise_Quit($msg){
	global $Embedded;
	if (!$Embedded){
		Wise_Raw("QUIT :$msg");
	}
	else {
		Wise_Raw($msg);
	}
}

//Wise_PartChannel(): Leave the channel
function Wise_partChannel($Chan){
	global $Embedded;
	if (empty($Chan)){
		return false;
	}
	if (!$Embedded){
		Wise_Raw("PART $Chan");
	}
	else {
		Wise_Raw($Chan);
	}
}

//Wise_JoinChannel(): Leave the channel
function Wise_JoinChannel($Chan){
	global $Embedded;
	if (empty($Chan)){
		return false;
	}
	if (!$Embedded){
		Wise_Raw("JOIN $Chan");
	}
	else {
		Wise_Raw($Chan);
	}
}

//Wise_Raw(): Lets you send a raw message to the IRC server
function Wise_Raw($msg){
	global $Embedded;
	if (empty($msg)){
		return false;
	}
	echo trim($msg), "\n";
}

//Wise_Reload(): Reloads the config for the main bot script
function Wise_Reload(){
	global $Embedded;
	if (!$Embedded){
		Wise_Raw(":RELOAD:");
	}
}

//Wise_Sleep(): Makes the main bot script sleep for a specified amount of time
function Wise_Sleep($time){
	global $Embedded;
	$time=intval($time);
	if ($time <= 0){
		$time=1;
	}
	if ($time > 10){
		$time=10;
	}
	if (!$Embedded){
		Wise_Raw(":SLEEP:$time");
	}
}

function Wise_Eval($code){
	global $Embedded;
	if (empty($code)){
		return false;
	}
	if (!$Embedded){
		Wise_Raw(":EVAL:".urlencode($code));
	}
	return true;
}

function Wise_timer($Code, $When=NULL){
	global $Embedded;
	if (is_null($When)){
		$When=time()+60;
	}
	if (!$Embedded){
		if ($Code{0} != ':'){
			$Code==':'.$Code;
		}
		$res=db_query("INSERT INTO offline_cmds (Rawline, TimeStamp) VALUES('".addslashes($Code)."', '$When')");
		if (!$res || db_affected_rows()==0){
			return 0;
		}
		else {
			return db_last_auto_id();
		}
	}
	return -1;
}

function Wise_timer_exists($Code){
	global $Embedded;
	if (is_null($When)){
		$When=time()+60;
	}
	if (is_numeric($Code)){
		$query="SELECT 1 FROM offline_cmds WHERE ID='{$Code}'";
	}
	else {
		if ($Code{0} != ':'){
			$Code==':'.$Code;
		}
		$query="SELECT 1 FROM offline_cmds WHERE RawLine='{$Code}'";
	}
	$res=db_query($query);
	if (!$res || db_num_rows($res)==0){
		return false;
	}
	return true;
}


function Wise_timer_remove($Timer){
	global $Embedded;
	if (is_numeric($Timer)){
		$query="DELETE FROM offline_cmds WHERE ID='{$Timer}'";
	}
	else {
		if ($Timer{0} != ':'){
			$Timer=':'.$Timer;
		}
		$query="DELETE FROM offline_cmds WHERE RawLine='{$Timer}'";
	}
	$res=db_query($query);
	if (!$res || db_affected_rows()==0){
		return 0;
	}
	else {
		return true;
	}
}

function Wise_cancel_cmd(){
	echo ':CANCEL:';
}
?>
