<?php
set_time_limit(15);
//Include required files
require_once("/home/WiserBot/data/Wiser/common/mysql.php");
require_once("/home/WiserBot/data/Wiser/common/io.php");
require_once("/home/WiserBot/data/Wiser/classes/bot.class.php");
require_once("/home/WiserBot/data/Wiser/classes/user.class.php");
require_once("/home/WiserBot/data/Wiser/classes/channel.class.php");


$__DB_LINK=db_connect(MYSQL_HOST, MYSQL_UNAME, MYSQL_PWORD, MYSQL_DB);
if (!$__DB_LINK && file_exists("./install.php")){
	header("Location: install.php");
	exit;
}

//Create a bot instance so that the db can be easly accessed in most cases.
$Bot=new Bot();
function header_html($title){
	$xul=isset($_GET['wiserxul']);
	include('header.php');
}

function footer(){
	$xul=isset($_GET['wiserxul']);
	include('footer.php');
}

function websafe($txt){
	$txt=str_replace(chr(160),chr(32),$txt);
	$txt=htmlentities($txt);
	return $txt;
}

function ConvertCodes($string){
	$Colors=array("#FFFFFF","#000000","#00007C","#009000",
						"#FF0000","#7C0000","#9C009C","#FF7C00",
						"#FFFF00","#00FF00","#009090","#00FFFF",
						"#0000FF","#FF00FF","#7C7C7C","#D0D0D0");
	$string=htmlspecialchars($string);
	$string=getURLcodes($string);
	if(strpos($string, chr(2))!==false){
		$parts=explode(chr(2), $string);
		$str=$parts[0];
		for ($i=1; $i<count($parts); $i++){
			if ($i%2){
				$str.="<SPAN STYLE=\"font-weight: bold\">".$parts[$i];
			}
			else {
				$str.="</SPAN>".$parts[$i];
			}
		}
		$string=$str;
		$amt1=count(explode("<SPAN",$string));
		$amt2=count(explode("</SPAN>", $string));
		while ($amt1>$amt2){
			$string.="</SPAN>";
			$amt2++;
		}
	}
	if(strpos($string, chr(31))!==false){
		$parts=explode(chr(31), $string);
		$str=$parts[0];
		for ($i=1; $i<count($parts); $i++){
			if ($i%2){
				$str.="<SPAN STYLE=\"text-decoration: underline;\">".$parts[$i];
			}
			else {
				$str.="</SPAN>".$parts[$i];
			}
		}
		$string=$str;
		$amt1=count(explode("<SPAN",$string));
		$amt2=count(explode("</SPAN>", $string));
		while ($amt1>$amt2){
			$string.="</SPAN>";
			$amt2++;
		}
	}
	if (strpos($string, chr(3)) !== false){
		$parts=explode(chr(3), $string);
		$str=$parts[0];
		for ($i=1; $i<count($parts); $i++){
			if ($i%2){
				ereg("^([0-9,]+)",$parts[$i], $UserColors);
				$parts[$i]=str_replace($UserColors[1], '', $parts[$i]);

				if (empty($UserColors[1])){
					$fg=1;
					$bg=0;
				}
				elseif (strpos($UserColors[1], ',') !== false){
					list($fg, $bg)=explode(',',$UserColors[1]);
				}
				else {
					$fg=$UserColors[1];
					$bg=0;
				}

				if (empty($bg)){
					$bg=0;
				}
				if (empty($fg)){
					$fg=1;
				}
				$fg=$Colors[$fg];
				$bg=$Colors[$bg];
				$str.="<SPAN STYLE=\"background: $bg; color: $fg;\">".$parts[$i];
			}
			else {
				$str.="</SPAN>".$parts[$i];
			}
		}
		$string=$str;
		$amt1=count(explode("<SPAN",$string));
		$amt2=count(explode("</SPAN>", $string));
		while ($amt1>$amt2){
			$string.="</SPAN>";
			$amt2++;
		}
	}
	if (strpos($string, chr(22)) !== false){
		$parts=explode(chr(22), $string);
		$str=$parts[0];
		for ($i=1; $i<count($parts); $i++){
			if ($i%2){
				$str.="<SPAN STYLE=\"background: {$Colors[1]}; color: {$Colors[0]};\">".$parts[$i];
			}
			else {
				$str.="</SPAN>".$parts[$i];
			}
		}
		$string=$str;
		$amt1=count(explode("<SPAN",$string));
		$amt2=count(explode("</SPAN>", $string));
		while ($amt1>$amt2){
			$string.="</SPAN>";
			$amt2++;
		}
	}
	if (strpos($string, chr(15)) !== false){
		$parts=explode(chr(15), $string);
		$str=$parts[0];
		for ($i=1; $i<count($parts); $i++){
			if ($i%2){
				$str.="<SPAN STYLE=\"background: {$Colors[0]}; color: {$Colors[1]};\">".$parts[$i];
			}
			else {
				$str.="</SPAN>".$parts[$i];
			}
		}
		$string=$str;
		$amt1=count(explode("<SPAN",$string));
		$amt2=count(explode("</SPAN>", $string));
		while ($amt1>$amt2){
			$string.="</SPAN>";
			$amt2++;
		}
	}

	$string=str_replace('</SPAN>',chr(1).'</SPAN>',$string);
	$regex='!<SPAN STYLE="(.[^>]*)"><SPAN STYLE="(.[^>]*)">(.[^'.chr(1).']*)'.chr(1).'</SPAN>!i';
	while (preg_match($regex, $string)){
		$string=preg_replace($regex,'<SPAN STYLE="$1 $2">$3</SPAN>',$string);
	}
	$string=str_replace(chr(1),'',$string);

	$string=str_replace('</SPAN>',chr(1).'</SPAN>',$string);
	$regex='!<SPAN (.[^>]*)><A (.[^>]*)>(.[^'.chr(1).']*)'.chr(1).'</SPAN>!i';
	$string=preg_replace($regex,'<A $2 $1>$3',$string);
	$string=str_replace(chr(1),'',$string);

	return $string;
}

//Turns URLs in a string to a hyperlink
function getURLCodes($str){
	if (preg_match_all("!((ht|f)tp://(.[^ ]*))!i",$str, $matches)){
		foreach ($matches[0] as $parts){
			$Replacement='<A HREF="'.$parts.'" TARGET="_blank">';
			if (strlen($parts) > 120){
				$Replacement.=substr($parts, 0, 120)."<BR>\n".substr($parts, 120);
			}
			else {
				$Replacement.=$parts;
			}
			$Replacement.='</A>';
			$str=str_replace($parts, $Replacement, $str);
		}
	}
	return $str;
}
?>
