<?php
include('common/mysql.php'); //Mysql wrapper functions
include('common/servers.php'); //Functions that mess with servers
include('classes/bot.class.php'); //Bot class used to provide easy access to information about the bot.
include('classes/user.class.php'); //User class used to provide easy access to information about the nick.
include('classes/channel.class.php'); //Channel class used to provide easy access to information about the channel.
include('common/io.php'); //Custom input/output functions (mostly output).
include('common/API.php'); //API for sending info to the server.

$__DEBUG__=false;
if (stristr(implode(' ',$_SERVER['argv']), '-d')!==false){
	$__DEBUG__=true;
}

function getTimer(){
	global $__MARK_TIMERS, $__MARK_TIMERS_STR;
	$timer=mysql_query('SELECT RawLine, ID FROM offline_cmds WHERE TimeStamp <= UNIX_TIMESTAMP() ORDER BY TimeStamp');
	if ($timer && $return=db_get_row($timer)){
		db_query("DELETE FROM offline_cmds WHERE ID='{$return->ID}'");
		if ($__MARK_TIMERS){
			$return->RawLine=$__MARK_TIMERS_STR.$return->RawLine;
		}
		return $return->RawLine;
	}
	return false;
}

//This function will determin where to get a line of IRC input from
function getLine($net, $timeout){
	if ($net){
		//output('Got a line from the socket');
		//Set the timeout to 5 seconds.
		socket_set_timeout($net, $timeout, 0);
		$line=fgets($net, 1024);
		while (strlen($line)==0){
			$line=getTimer();
			if ($line===false){
				//Set the timeout to 5 seconds.
				socket_set_timeout($net, 5, 0);
				$line=fgets($net, 1024);
			}
		}
		return $line;	
	}
	else if ($line=getTimer()){
		return $line;
	}
	output('Neither the mysql or net connection is valid.');
	return NULL;
}


function mctime(){
	list($t1, $t2)=explode(' ',microtime());
	return doubleval($t1)+intval($t2);
}

//Never timeout.
set_time_limit(0);
//Ignore the stop button, incase people load it through their browser.
//It's a bad idea, but some people may have to.
ignore_user_abort(1);

if (isset($_SERVER['REMOTE_ADDR'])){
	echo "<P STYLE=\"font-size:200%\">Please press the stop button now.  Also try to get the command line version of ";
	echo "php and use that to run this bot.  It will be much better.</P>";
	flush();
}
//Inital value for $__RECONNECT.  It will be changed to the database value if a connection is actually made.
$__RECONNECT=false;
$__SERVER_ID=false;
$__MARK_TIMERS=false;
$__MARK_TIMERS_STR='*';
//Init mysql connection so that we can get the information needed
$__DB_LINK=db_connect(MYSQL_HOST, MYSQL_UNAME, MYSQL_PWORD, MYSQL_DB);
if (!$__DB_LINK){
	echo "Cannot connect to database\n";
	exit;
}
//This is so that the start time isn't re-set if the bot just pings out or something.
$startTimeSet=false;
do { //This ensures the bot is run once, and it makes it so it can run again if it gets disconnected for some reason.

	//reset the database so that it's like the bot was just started up (incase of reconnects or improper shutdowns)
	resetDb();
	//Initlize a new bot class
	$Bot=new Bot();
	if ($startTimeSet==false){
		//Set the inital start time to now.
		$Bot->setInfo('start_time',time());
		$startTimeSet=time();
	}
	else {
		$Bot->setInfo('start_time',$startTimeSet);
	}

	$Bot->setInfo('log_date',time());

	//Get some configuration varaibles
	$__RECONNECT=$Bot->setInfo('reconnect',$Bot->getCfg('server_reconnect'));
	if (!isset($__RETRY_AMOUNT)) $__RETRY_AMOUNT=$Bot->getCfg('server_retry');
	$__MARK_TIMERS=$Bot->getCfg('mark_timers');
	$__MARK_TIMERS_STR=$Bot->getCfg('mark_timers_string');

	//Create some temporary variables to use while we put together the strings.
	$Nick=$Bot->getNick();
	$RealName=$Bot->getRealName();


	//Now we need to get the server that we are going to connect to.
	list($__SERVER_ID,$Server)=getServer($Bot, $__SERVER_ID); //servers.php

	if ($Server==false){
		//No server could be selected.  Show error and exit loop.
		output("No server could be selected from the list. (List may be empty?)");
		break;
	}

	//Break the server into the host and port number and try to connect.
	if (strstr($Server, ':')==false){
		if ($__DEBUG__){
			output('Using default port of 6667');
		}
		$Server.=':6667';
	}
	$Server=explode(':',$Server);

	//Try to connect
	output("Trying to connect to $Server[0]:$Server[1]");
	$__CON_ERROR_NO=$__CON_ERROR_STR='';
	$__IRC_CONNECTION=@fsockopen($Server[0],$Server[1],$__CON_ERROR_NO,$__CON_ERROR_STR,(int)$Bot->getCfg('con_timeout'));
	
	if (!$__IRC_CONNECTION){
		//Couldn't connect.  Show error message and exit loop.  I may extend this to try new server sometime later.
		output("Couldn't connect to IRC server");
		output("($__CON_ERROR_NO) $__CON_ERROR_STR");
		$__IRC_CONNECTION=NULL;
	}
	else{
		//We should be connected, so send the USER and NICK elements, and start the loop to recieve data.
		//Also store the server information into the database.
		$Bot->setInfo('current_server',$Server[0].':'.$Server[1]);
		msgServer("USER $Nick $Server[0] $Server[0] :$RealName");
		msgServer("NICK $Nick");
	}

	//Start loop that catches data for the rest of the program.
	while ($line=getLine($__IRC_CONNECTION, $Bot->getCfg('irc_line_timeout'))){
		$start=mctime();
		//Replace chr(160) with chr(32).  Makes stuff eaiser to work with.
		$line=trim(str_replace(chr(16), chr(32), $line));
		output($line);
		if (substr($line, 0, strlen($__MARK_TIMERS_STR))==$__MARK_TIMERS_STR){
			$line=substr($line, strlen($__MARK_TIMERS_STR));
		}

		if (strtoupper(substr($line, 0, 4))=='PING'){
			msgServer("PONG".substr($line, 4));
		}


		//Get the pattern and matches for this message if it will break up.
		$Pattern=$Matches=$Type=$Info=null;
		$Info=getBreakPattern($line);

		//if it didn't break up, then there is nothing I can do with it, so continue to the next one.
		if ($Info==null){
			continue;
		}

		$Info=makeDataArray($Info);
		//Free up some memory
		unset($Matches);
		unset($Pattern);
		unset($Type);


		//if (strstr($line, 'quit') && $Info['NICK']=='kicken'){
		//	exit;
		//}

		$User=new User($Info['NICK']);

		//Log the information of this line to the db
		$Bot->logInfo($Info,$User);


		//Now we will run the server code handlers if there is one.
		if ($Info['BREAK_TYPE']=='SERVERCODE' && $Bot->cmdExists($Info['CODE'], true)){
			$Bot->runCommand($User, $Info, $Info['CODE'], true);
		}

		//Now we will run the normal code handlers if there is one.
		if ($Info['BREAK_TYPE']=='NORMALMSG' && $Bot->cmdExists($Info['TYPE'], true)){
			$Bot->runCommand($User, $Info, $Info['TYPE'], true);
		}

		$CmdKeys=$Bot->getCfg('command_key');
		if ($Info['TYPE']=='PRIVMSG' && strToUpper($Info['DEST'])==strToUpper($Bot->getNick())){
			if (strlen($Info['MSG']) > 0 && !strstr($CmdKeys, $Info['MSG']{0})){
				$Info['MSG']=substr($CmdKeys, 0, 1).$Info['MSG'];
			}
		}

		$Bot->runModules($Info);
		//Now, see if they want to run a command.  At the moment, we just search for commands at the beginning of the 
		//message.  Commands start with a key defined in the options.
		if ($Info['RUNABLE'] && preg_match("/^[$CmdKeys](.[^ ]*)/",$Info['MSG'], $Matches)){
			$Matches[1]=trim(strtolower($Matches[1]));
			if ($Matches[1]=='reload'){
				$Bot->reload();
			}
			else if ($Bot->cmdExists($Matches[1], false)){
				$Bot->runCommand($User, $Info, false);
			}
			else {
				output("No such command: {$Matches[1]}");
			}
		}


		$end=mctime();
		if ($__DEBUG__){
			output("Start: $start; End: $end; Run Time: ".($end-$start));
		}
		fflush($__IRC_CONNECTION);
		flush();
	}
	if ($__DEBUG__){
		output('Lost connection! ');
		output('$__IRC_CONNECTION='.$__IRC_CONNECTION.'; is_resource('.is_resource($__IRC_CONNECTION).')');
	}
	$__RECONNECT=$Bot->getInfo('reconnect');
}while($__RECONNECT==true && $__RETRY_AMOUNT--);
?>
